unit MFrame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Position,
  StdCtrls, Grids, Buttons, ComCtrls, ImgList;

type
  TForm1 = class(TForm)
    TurnLabel: TLabel;
    CompMoveButton: TButton;
    DepthComboBox: TComboBox;
    ProgressBar: TProgressBar;
    Start1: TBitBtn;
    Start2: TBitBtn;
    Rotate: TBitBtn;
    DrawGrid: TDrawGrid;
    LabelA: TLabel;
    DeskImages: TImageList;
    HistoryListBox: TListBox;
    LabelB: TLabel;
    LabelC: TLabel;
    LabelD: TLabel;
    LabelE: TLabel;
    LabelF: TLabel;
    LabelG: TLabel;
    LabelH: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    BreakButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure DrawGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DrawGridClick(Sender: TObject);
    procedure RotateClick(Sender: TObject);
    procedure AddHistoryString(Count: Integer; Turn: State; Move: TMove);
    procedure CompMoveButtonClick(Sender: TObject);
    procedure DrawGridExit(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BreakButtonClick(Sender: TObject);
    procedure Start1Click(Sender: TObject);
    procedure Start2Click(Sender: TObject);
  private
    { Private declarations }
    IsFlipped: Boolean;          {    ...}
    IsStartSelected: Boolean;    {   }
    ManualMove: TMove;           {}
    MoveCount: Integer;          { }
    {    }
    LastCount: Integer;       {   }
    CurrentDepth: Integer;    {   auto}
    Procedure LabelLayout;    { }
    Procedure WinMessage;     {        }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Pos: TPosition;
implementation

{$R *.DFM}
var StartPosition1: TBoard=(
(White,White,White,Space,Space,Space,Space,Space),
(White,White,White,Space,Space,Space,Space,Space),
(White,White,White,Space,Space,Space,Space,Space),
(White,White,White,Space,Space,Space,Space,Space),
(Space,Space,Space,Space,Space,Black,Black,Black),
(Space,Space,Space,Space,Space,Black,Black,Black),
(Space,Space,Space,Space,Space,Black,Black,Black),
(Space,Space,Space,Space,Space,Black,Black,Black));

var StartPosition2: TBoard=(
(White,White,White,White,Space,Space,Space,Space),
(White,White,White,Space,Space,Space,Space,Space),
(White,White,Space,Space,Space,Space,Space,Space),
(White,Space,Space,Space,Space,Space,Space,Space),
(Space,Space,Space,Space,Space,Space,Space,Black),
(Space,Space,Space,Space,Space,Space,Black,Black),
(Space,Space,Space,Space,Space,Black,Black,Black),
(Space,Space,Space,Space,Black,Black,Black,Black));

procedure TForm1.FormCreate(Sender: TObject);
begin
  Pos:=TPosition.Create;
  Pos.SetInitialPosition(StartPosition1);
  Pos.RestartGame;

  IsFlipped:=False;
  IsStartSelected:=False;
  MoveCount:=0;
  DepthComboBox.ItemIndex:=0;

  LastCount:=15;
  CurrentDepth:=4;

  DrawGrid.Width:=DrawGrid.DefaultColWidth*DrawGrid.ColCount+(DrawGrid.ColCount+1)*DrawGrid.GridLineWidth+2{border};
  DrawGrid.Height:=DrawGrid.DefaultRowHeight*DrawGrid.RowCount+(DrawGrid.RowCount+1)*DrawGrid.GridLineWidth+2;
  LabelLayout;

  Randomize;
end;

procedure TForm1.AddHistoryString(Count: Integer; Turn: State; Move: TMove);
begin
  if Turn=White then
    HistoryListBox.Items.Add(Format('%.2d: %s%d-%s%d ',[Count div 2+1,Chr(Ord(Move.MoveFrom.X)+Ord('a')), Move.MoveFrom.Y, Chr(Ord(Move.MoveTo.X)+Ord('a')),Move.MoveTo.Y]))
  else
    HistoryListBox.Items[(Count-1) div 2]:=HistoryListBox.Items[(Count-1) div 2]+Format('%s%d-%s%d',[Chr(Ord(Move.MoveFrom.X)+Ord('a')),Move.MoveFrom.Y,Chr(Ord(Move.MoveTo.X)+Ord('a')),Move.MoveTo.Y]);
    HistoryListBox.ItemIndex:=(Count-1) div 2;
    HistoryListBox.ItemIndex:=-1;
end;

procedure ProgressHandler(Cur,Max:Integer);
begin
  Form1.ProgressBar.Position:=(Cur*100) div Max;
  Form1.LastCount:=Max;
end;

procedure TForm1.DrawGridExit(Sender: TObject);
begin
  IsStartSelected:=False;
  TDrawGrid(Sender).Refresh;
end;


procedure TForm1.DrawGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
  var
    BMP: TBitmap;
begin
  {    }
  BMP:=TBitmap.Create;
  DeskImages.GetBitmap(2,BMP);
  if not((odd(ACol)and odd(ARow)) or ((not odd(ACol)) and (not odd(ARow)))) then
  begin
    { }
    if IsFlipped then
    begin
      case Pos.Get(HNum(7-ACol),ARow+1) of
      Space:
        DeskImages.GetBitmap(0,BMP);
      Black:
        if IsStartSelected and (ManualMove.MoveFrom.X=HNum(7-ACol)) and (ManualMove.MoveFrom.Y=ARow+1) then
          DeskImages.GetBitmap(5,BMP)
        else
          DeskImages.GetBitmap(3,BMP);
      White:
        if IsStartSelected and (ManualMove.MoveFrom.X=HNum(7-ACol)) and (ManualMove.MoveFrom.Y=ARow+1) then
          DeskImages.GetBitmap(4,BMP);
        else
          DeskImages.GetBitmap(2,BMP);
      end
    end
    else
      case Pos.Get(HNum(ACol),8-ARow) of
      Space:
        DeskImages.GetBitmap(0,BMP);
      Black:
        if IsStartSelected and (ManualMove.MoveFrom.X=HNum(ACol)) and (ManualMove.MoveFrom.Y=8-ARow) then
          DeskImages.GetBitmap(5,BMP)
        else
          DeskImages.GetBitmap(3,BMP);
      White:
        if IsStartSelected and (ManualMove.MoveFrom.X=HNum(ACol)) and (ManualMove.MoveFrom.Y=8-ARow) then
          DeskImages.GetBitmap(4,BMP)
        else
          DeskImages.GetBitmap(2,BMP);
      end
    end
  else
  begin
    { }
    if IsFlipped then
    begin
      case Pos.Get(HNum(7-ACol),ARow+1) of
      Space:
        DeskImages.GetBitmap(1,BMP);
      Black:
        if IsStartSelected and (ManualMove.MoveFrom.X=HNum(7-ACol)) and (ManualMove.MoveFrom.Y=ARow+1) then
          DeskImages.GetBitmap(9,BMP)
        else
          DeskImages.GetBitmap(7,BMP);
      White:
        if IsStartSelected and (ManualMove.MoveFrom.X=HNum(7-ACol)) and (ManualMove.MoveFrom.Y=ARow+1) then
          DeskImages.GetBitmap(8,BMP)
        else
          DeskImages.GetBitmap(6,BMP);
      end;
    end
    else
    begin
      case Pos.Get(HNum(ACol),8-ARow) of
      Space:
        DeskImages.GetBitmap(1,BMP);
      Black:
        if IsStartSelected and (ManualMove.MoveFrom.X=HNum(ACol)) and (ManualMove.MoveFrom.Y=8-ARow) then
          DeskImages.GetBitmap(9,BMP)
        else
          DeskImages.GetBitmap(7,BMP);
      White:
        if IsStartSelected and (ManualMove.MoveFrom.X=HNum(ACol)) and (ManualMove.MoveFrom.Y=8-ARow) then
          DeskImages.GetBitmap(8,BMP)
        else
          DeskImages.GetBitmap(6,BMP);
      end;
    end;
  end;
  With Sender as TDrawGrid do
  begin
    canvas.Draw(Rect.Left, Rect.Top, BMP);
  end;
  BMP.Destroy;
end;

procedure TForm1.DrawGridClick(Sender: TObject);
var
  X,Y: Integer;
begin
  {     }
  X:=TDrawGrid(Sender).Selection.Left+1;
  Y:=TDrawGrid(Sender).Selection.Top+1;
  if(IsFlipped) then
    X:=9-X
  else
    Y:=9-Y;

  if IsStartSelected then
  begin
    { }
    IsStartSelected:=False;
    ManualMove.MoveTo.X:=HNum(X-1);
    ManualMove.MoveTo.Y:=Y;
    if Pos.IsMovePossible(ManualMove) then
    begin
      MoveCount:=MoveCount+1;                             { }
      AddHistoryString(MoveCount,Pos.GetTurn,ManualMove); {   }
      Pos.MakeMove(ManualMove);                           { }
      Pos.ChangeTurn;                                     {  }
      if Pos.GetTurn=White then                           {    }
        TurnLabel.Caption:=' '
      else
        TurnLabel.Caption:=' ';
      {      }
      if Pos.GetWinner<>Space then WinMessage;
    end
    else
    begin
      MessageBox(0,' ','!!!',MB_OK);
    end
  end
  else
  begin
    { }
    if Pos.Get(HNum(X-1),Y)=Pos.GetTurn then
    begin
      IsStartSelected:=True;
      ManualMove.MoveFrom.X:=HNum(X-1);
      ManualMove.MoveFrom.Y:=Y;
    end;
  end;
  DrawGrid.Refresh;
end;

procedure TForm1.RotateClick(Sender: TObject);
begin
  IsFlipped:=not IsFlipped;
  DrawGrid.Refresh;
  LabelLayout;
end;

procedure TForm1.CompMoveButtonClick(Sender: TObject);
var
  M: TMove;
  D: Cardinal;
  Hour,Min,Sec,MSec: Word;
  T1,T2:TDateTime;
begin
  {  }
  TButton(Sender).Enabled:=False;
  DrawGrid.Enabled:=False;
  Start1.Enabled:=False;
  Start2.Enabled:=False;
  Rotate.Enabled:=False;
  DepthComboBox.Enabled:=False;
  BreakButton.Enabled:=True;
  {  }
  If DepthComboBox.ItemIndex<>0 then
  begin
    {     }
    D:=DepthComboBox.ItemIndex;
  end
  else
  begin
  {   }
    D:=CurrentDepth;
  end;
  {  }
  T1:=Time;
  M:=Pos.GetBestMove(D,ProgressHandler);
  T2:=Time;
  if not((M.MoveFrom.X=M.MoveTo.X) and (M.MoveFrom.Y=M.MoveTo.Y)) then
  begin
    {   ,   }
    {      ( auto)}
    If DepthComboBox.ItemIndex=0 then
    begin
      DecodeTime(T2-T1,Hour,Min,Sec,MSec);
      if(Min*60000+Sec*1000+MSec)>20000 then
      begin
        if CurrentDepth<>1 then CurrentDepth:=CurrentDepth-1;
      end
      else
      begin
        if (Min*60000+Sec*1000+MSec)*LastCount<20000 then CurrentDepth:=CurrentDepth+1;
      end;
    end;

    {      }
    MoveCount:=MoveCount+1;                             { }
    AddHistoryString(MoveCount,Pos.GetTurn,M);
    Pos.MakeMove(M);
    DrawGrid.Refresh;
    {    }
    Pos.ChangeTurn;
    if Pos.GetTurn=White then
      TurnLabel.Caption:=' '
    else
      TurnLabel.Caption:=' ';
  end;
  {  }
  TButton(Sender).Enabled:=True;
  DrawGrid.Enabled:=True;
  Start1.Enabled:=True;
  Start2.Enabled:=True;
  Rotate.Enabled:=True;
  DepthComboBox.Enabled:=True;
  BreakButton.Enabled:=False;
  {  }
  ProgressBar.Position:=0;
  {      }
  if Pos.GetWinner<>Space then WinMessage;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Pos.Break;
end;

Procedure TForm1.LabelLayout;
const
  SP=3;
  CW=5;
begin
  LabelA.Top:=DrawGrid.Top+DrawGrid.Height+SP;
  LabelA.Left:=DrawGrid.Left+0*(DrawGrid.DefaultColWidth + DrawGrid.GridLineWidth) + DrawGrid.DefaultColWidth div 2;
  if isFlipped then LabelA.Caption:='h' else LabelA.Caption:='a';

  LabelB.Top:=DrawGrid.Top+DrawGrid.Height+SP;
  LabelB.Left:=DrawGrid.Left+1*(DrawGrid.DefaultColWidth + DrawGrid.GridLineWidth) + DrawGrid.DefaultColWidth div 2;
  if isFlipped then LabelB.Caption:='g' else LabelB.Caption:='b';

  LabelC.Top:=DrawGrid.Top+DrawGrid.Height+SP;
  LabelC.Left:=DrawGrid.Left+2*(DrawGrid.DefaultColWidth + DrawGrid.GridLineWidth) + DrawGrid.DefaultColWidth div 2;
  if isFlipped then LabelC.Caption:='f' else LabelC.Caption:='c';

  LabelD.Top:=DrawGrid.Top+DrawGrid.Height+SP;
  LabelD.Left:=DrawGrid.Left+3*(DrawGrid.DefaultColWidth + DrawGrid.GridLineWidth) + DrawGrid.DefaultColWidth div 2;
  if isFlipped then LabelD.Caption:='e' else LabelD.Caption:='d';

  LabelE.Top:=DrawGrid.Top+DrawGrid.Height+SP;
  LabelE.Left:=DrawGrid.Left+4*(DrawGrid.DefaultColWidth + DrawGrid.GridLineWidth) + DrawGrid.DefaultColWidth div 2;
  if isFlipped then LabelE.Caption:='d' else LabelE.Caption:='e';

  LabelF.Top:=DrawGrid.Top+DrawGrid.Height+SP;
  LabelF.Left:=DrawGrid.Left+5*(DrawGrid.DefaultColWidth + DrawGrid.GridLineWidth) + DrawGrid.DefaultColWidth div 2;
  if isFlipped then LabelF.Caption:='c' else LabelF.Caption:='f';

  LabelG.Top:=DrawGrid.Top+DrawGrid.Height+SP;
  LabelG.Left:=DrawGrid.Left+6*(DrawGrid.DefaultColWidth + DrawGrid.GridLineWidth) + DrawGrid.DefaultColWidth div 2;
  if isFlipped then LabelG.Caption:='b' else LabelG.Caption:='g';

  LabelH.Top:=DrawGrid.Top+DrawGrid.Height+SP;
  LabelH.Left:=DrawGrid.Left+7*(DrawGrid.DefaultColWidth + DrawGrid.GridLineWidth) + DrawGrid.DefaultColWidth div 2;
  if isFlipped then LabelH.Caption:='a' else LabelH.Caption:='h';

  { }
  Label1.Top:=DrawGrid.Top+7*(DrawGrid.DefaultRowHeight+DrawGrid.GridLineWidth)+(DrawGrid.DefaultRowHeight div 2)-CW;
  Label1.Left:=DrawGrid.Left+DrawGrid.Width+SP;
  if isFlipped then Label1.Caption:='8' else Label1.Caption:='1';

  Label2.Top:=DrawGrid.Top+6*(DrawGrid.DefaultRowHeight+DrawGrid.GridLineWidth)+(DrawGrid.DefaultRowHeight div 2)-CW;
  Label2.Left:=DrawGrid.Left+DrawGrid.Width+SP;
  if isFlipped then Label2.Caption:='7' else Label2.Caption:='2';

  Label3.Top:=DrawGrid.Top+5*(DrawGrid.DefaultRowHeight+DrawGrid.GridLineWidth)+(DrawGrid.DefaultRowHeight div 2)-CW;
  Label3.Left:=DrawGrid.Left+DrawGrid.Width+SP;
  if isFlipped then Label3.Caption:='6' else Label3.Caption:='3';

  Label4.Top:=DrawGrid.Top+4*(DrawGrid.DefaultRowHeight+DrawGrid.GridLineWidth)+(DrawGrid.DefaultRowHeight div 2)-CW;
  Label4.Left:=DrawGrid.Left+DrawGrid.Width+SP;
  if isFlipped then Label4.Caption:='5' else Label4.Caption:='4';

  Label5.Top:=DrawGrid.Top+3*(DrawGrid.DefaultRowHeight+DrawGrid.GridLineWidth)+(DrawGrid.DefaultRowHeight div 2)-CW;
  Label5.Left:=DrawGrid.Left+DrawGrid.Width+SP;
  if isFlipped then Label5.Caption:='4' else Label5.Caption:='5';

  Label6.Top:=DrawGrid.Top+2*(DrawGrid.DefaultRowHeight+DrawGrid.GridLineWidth)+(DrawGrid.DefaultRowHeight div 2)-CW;
  Label6.Left:=DrawGrid.Left+DrawGrid.Width+SP;
  if isFlipped then Label6.Caption:='3' else Label6.Caption:='6';

  Label7.Top:=DrawGrid.Top+1*(DrawGrid.DefaultRowHeight+DrawGrid.GridLineWidth)+(DrawGrid.DefaultRowHeight div 2)-CW;
  Label7.Left:=DrawGrid.Left+DrawGrid.Width+SP;
  if isFlipped then Label7.Caption:='2' else Label7.Caption:='7';

  Label8.Top:=DrawGrid.Top+0*(DrawGrid.DefaultRowHeight+DrawGrid.GridLineWidth)+(DrawGrid.DefaultRowHeight div 2)-CW;
  Label8.Left:=DrawGrid.Left+DrawGrid.Width+SP;
  if isFlipped then Label8.Caption:='1' else Label8.Caption:='8';
end;

procedure TForm1.BreakButtonClick(Sender: TObject);
begin
  Pos.Break;
end;

procedure TForm1.Start1Click(Sender: TObject);
begin
  if MoveCount<>0 then
  begin
    if MessageBox(Form1.Handle,' ,    ?','',MB_YESNO)=IDNO then
      begin
        exit;
      end
  end;
  Pos.SetInitialPosition(StartPosition1);
  Pos.RestartGame;
  MoveCount:=0;
  HistoryListBox.Items.Clear;
  Pos.ChangeTurn(White);
  TurnLabel.Caption:=' ';
  IsFlipped:=False;
  IsStartSelected:=False;
  LastCount:=15;
  CurrentDepth:=4;
  LabelLayout;
  DrawGrid.Refresh;
end;

procedure TForm1.Start2Click(Sender: TObject);
begin
  if MoveCount<>0 then
  begin
    if MessageBox(Form1.Handle,' ,    ?','',MB_YESNO)=IDNO then
      begin
        exit;
      end
  end;
  Pos.SetInitialPosition(StartPosition2);
  Pos.RestartGame;
  MoveCount:=0;
  HistoryListBox.Items.Clear;
  Pos.ChangeTurn(White);
  TurnLabel.Caption:=' ';
  IsFlipped:=False;
  IsStartSelected:=False;
  LastCount:=15;
  CurrentDepth:=4;
  LabelLayout;
  DrawGrid.Refresh;
end;

Procedure TForm1.WinMessage;
var
  Winner: State;
  S: String;
begin
  Winner:=Pos.GetWinner;
  case winner of
  white:
    S:=' !!!';
  black:
    S:=' !!!';
  else
    S:='    ,       :)';
  end;
  MessageBox(Form1.Handle,PChar(S),' ',MB_OK);
  {     }
  Pos.RestartGame;
  MoveCount:=0;
  HistoryListBox.Items.Clear;
  Pos.ChangeTurn(White);
  TurnLabel.Caption:=' ';
  IsFlipped:=False;
  IsStartSelected:=False;
  LastCount:=15;
  CurrentDepth:=4;
  LabelLayout;
  DrawGrid.Refresh;
end;

end.
