{=====================================================================
     ,
   
( TPosition)
======================================================================}
unit Position;

interface

uses forms, sysutils;

  Type
    {  }
    CallBackPosition=Procedure (Current,Amount:Integer);

    {  }
    State=(Black, White, Space);

    {    }
    HNum=(a,b,c,d,e,f,g,h);
    VNum=1..8;

    { }
    TPlace=record
      X: HNum;
      Y: VNum;
    end;

    { }
    TMove=record
      MoveFrom: TPlace;
      MoveTo: TPlace;
    end;

    {   }
    PListEntry=^TMoveList;
    TMoveList=record
      Move: TMove;
      Next: PListEntry;
      Prev: PListEntry;
    end;

    { }
    TBoard= Array[HNum, VNum] of State;

    {  }
    TPosition=class(TObject)
      private
        Board : TBoard;                          {}
        InitialPosition: TBoard;                 { }
        Turn: State;                             { }
        Function GetMoveList():PListEntry;       {       }
        Procedure DelMoveList(List: PListEntry); {   }
        Function GoalFunc():Integer;             { }
        Function GoalFunc2():Integer;
        function _GetBestMove(Var BestMove: TMove; Depth: Cardinal; Progress:CallBackPosition=nil):Integer;
        function _GetBestMove2(Var BestMove: TMove; Depth: Cardinal;  Progress:CallBackPosition=nil):Integer;
      public
        {, }
        constructor Create; overload;
        constructor Create(Pattern: TPosition); overload;
        destructor Destroy; override;
        {  }
        Function Get(X: HNum; Y: VNum):State;
        {  }
        Function GetTurn: State;
        {  }
        Procedure CopyFrom(Pattern: TPosition);
        {   (   ) }
        Procedure SetInitialPosition(Pos: TBoard);
        {  }
        Procedure ChangeTurn(T:State=Space);
        {   }
        Procedure RestartGame;
        { }
        procedure SetPiece(X:HNum; Y:VNum; Color:State); overload;
        procedure SetPiece(Pos:TPlace; Color:State); overload;
        { }
        procedure RemovePiece(X:HNum; Y:VNum); overload;
        procedure RemovePiece(Pos:TPlace); overload;
        {  }
        procedure MakeMove(X1:HNum; Y1:VNum; X2:HNum; Y2:VNum); overload;
        procedure MakeMove(StartPos,EndPos: TPlace); overload;
        procedure MakeMove(M: TMove); overload;
        {  }
        function IsMovePossible(X1:HNum; Y1:VNum; X2:HNum; Y2:VNum):Boolean; overload;
        function IsMovePossible(StartPos,EndPos: TPlace):Boolean; overload;
        function IsMovePossible(M: TMove):Boolean; overload;
        {   }
        function GetBestMove(Depth: Cardinal=5; Progress:CallBackPosition=nil): TMove;
        {     ...}
        function GetWinner():State;
        {   }
        Procedure Break;
    end;

implementation
var
  BreakFlag: Boolean;

function max(a,b:cardinal):cardinal;
begin
  if a>b then max:=a else max:=b;
end;

function min(a,b:cardinal):cardinal;
begin
  if a>b then min:=b else min:=a;
end;

{--------------------------------------------------------------------}
{ /                                             }
{--------------------------------------------------------------------}

  constructor TPosition.Create;
  begin
    inherited Create;
    {initialisation}
    {      ...}
    Turn:=White;
    BreakFlag:=False;
  end;

  constructor TPosition.Create(Pattern: TPosition);
  begin
    inherited Create;
    {coping}
    CopyFrom(Pattern);
    BreakFlag:=False;
  end;

  destructor TPosition.Destroy;
  begin
    {       ...}
    inherited Destroy;
  end;

{-----------------------------------------------------------------}
{                              }
{-----------------------------------------------------------------}
  Function TPosition.Get(X: HNum; Y: VNum):State;
  begin
    Get:=Board[X,Y];
  end;

{-----------------------------------------------------------------}
{                              }
{-----------------------------------------------------------------}
  Function TPosition.GetTurn:State;
  begin
    GetTurn:=Turn;
  end;

{------------------------------------------------------------------}
{                                          }
{------------------------------------------------------------------}
  Procedure TPosition.CopyFrom(Pattern: TPosition);
  begin
    Board:=Pattern.Board;
    InitialPosition:=Pattern.InitialPosition;
    turn:=Pattern.Turn;
  end;


{-------------------------------------------------------------------}
{   (   )       }
{-------------------------------------------------------------------}
  Procedure TPosition.SetInitialPosition(Pos: TBoard);
  var
    i: VNum;
    j: HNum;
  begin
    for i:= Low(i) to High(i) do
    begin
      for j:=Low(j) to High(j) do
      begin
        InitialPosition[j,i]:=Pos[j,i];
      end
    end
  end;

{-------------------------------------------------------------------}
{       .         }
{-------------------------------------------------------------------}
  Procedure TPosition.ChangeTurn(T:State);
  begin
    if T=Space then
    begin
      if turn=White then
        turn:=Black
      else
        turn:=White;
    end
    else
    begin
      turn:=T;
    end;
  end;

{-------------------------------------------------------------------}
{                                             }
{-------------------------------------------------------------------}
  Procedure TPosition.RestartGame;
  var
    i: VNum;
    j: HNum;
  begin
    for i:= Low(i) to High(i) do
    begin
      for j:=Low(j) to High(j) do
      begin
        Board[j,i]:=InitialPosition[j,i];
      end
    end
  end;

{------------------------------------------------}
{     }
{------------------------------------------------}
  Function TPosition.GetMoveList():PListEntry;
    Type
      TDirection=(right,up,left,down);
      TTreeEntry=^TMovesTree;
      TMovesTree=record
        Disposition: TPlace;
        Root: TTreeEntry;
        SimpleStep: array [TDirection] of TTreeEntry;
        JumpStep: array [TDirection] of TTreeEntry;
      end;

    {      }
    procedure CreateTree(var PHead: TTreeEntry; Parent:TTreeEntry; X: HNum; Y: VNum; IsSimple: Boolean=True);

      {     }
      Procedure Initialize(var PHead: TTreeEntry; Parent: TTreeEntry; X: HNum; Y: VNum);
      var
        i: TDirection;
      begin
        new(PHead);
        PHead.Disposition.X:=X;
        PHead.Disposition.Y:=Y;
        PHead.Root:=Parent;
        for i:=Right to down do PHead^.SimpleStep[i]:=nil;
        for i:=Right to down do PHead^.JumpStep[i]:=nil;
      end;

      {       }
      function IsFirstTime(PNode: TTreeEntry; X: HNum; Y: VNum):Boolean;
      var
        PCurNode: TTreeEntry;
      begin
        PCurNode:=PNode^.Root;
        IsFirstTime:=True;
        While PCurNode<> nil do
        begin
          if (PCurNode^.Disposition.X=X) and (PCurNode^.Disposition.Y=Y) then
            begin
              IsFirstTime:=False;
              exit;
            end;
          PCurNode:=PCurNode^.Root;
        end;
      end;

    {  Create Tree}
    begin
      { }
      Initialize(PHead,Parent,X,Y);
      {   }
      if IsSimple then
      begin
      {      
         ,     }
        if (X<>High(X)) and (Board[Succ(X),Y] = Space) then
          Initialize(PHead^.SimpleStep[Right],PHead,Succ(X),Y);
        if (X<>Low(X)) and (Board[Pred(X),Y] = Space) then
          Initialize(PHead^.SimpleStep[Left],PHead,Pred(X),Y);
        if (Y<>High(Y)) and (Board[X,Succ(Y)] = Space) then
          Initialize(PHead^.SimpleStep[Up], PHead, X, Succ(Y));
        if (Y<>Low(Y)) and (Board[X,Pred(Y)] = Space) then
          Initialize(PHead^.SimpleStep[Down],PHead,X,Pred(Y));
      end;
      {    - 
         CreateTree }
       {}
       if (X<>High(X)) and (Succ(X)<>High(x)) and (Board[Succ(X),Y]<>Space) and (Board[Succ(Succ(X)),Y]=Space) and IsFirstTime(PHead,Succ(Succ(X)),Y) then
         CreateTree(PHead^.JumpStep[Right],PHead,Succ(Succ(X)),Y,False);
       {}
       if (X<>Low(X)) and (Pred(X)<>Low(x)) and (Board[Pred(X),Y]<>Space) and (Board[Pred(Pred(X)),Y]=Space) and IsFirstTime(PHead,Pred(Pred(X)),Y) then
         CreateTree(PHead^.JumpStep[Left],PHead,Pred(Pred(X)),Y,False);
       {}
       if (Y<>High(Y)) and (Succ(Y)<>High(Y)) and (Board[X,Succ(Y)]<>Space) and (Board[X,Succ(Succ(Y))]=Space) and IsFirstTime(PHead,X,Succ(Succ(Y))) then
         CreateTree(PHead^.JumpStep[Up],PHead,X,Succ(Succ(Y)),False);
       {}
       if (Y<>Low(Y)) and (Pred(Y)<>Low(Y)) and (Board[X,Pred(Y)]<>Space) and (Board[X,Pred(Pred(Y))]=Space) and IsFirstTime(PHead,X,Pred(Pred(Y))) then
         CreateTree(PHead^.JumpStep[Down],PHead,X,Pred(Pred(Y)),False);
    end;

    {  ,  .}
    procedure DeleteTree(Head: TTreeEntry);
    var
      i: TDirection;
    begin
      {   }
      for i:=Right to Down do
      begin
        if Head^.SimpleStep[i]<>nil then DeleteTree(Head^.SimpleStep[i]);
        if Head^.JumpStep[i]<>nil then DeleteTree(Head^.JumpStep[i]);
      end;
      {    }
      dispose(Head);
    end;

    {         }
    procedure TreeToList(Tree: TTreeEntry; Node: TTreeEntry; var List: PListEntry);
    var
      i: TDirection;
      temp: PListEntry;
      IsFirstTime: Boolean;
    begin
      {    ,   ,   }
      if Tree<>Node then
      begin
        {          - }
        IsFirstTime:=True;
        temp:=List;
        while (temp<>nil) and (temp^.Move.MoveFrom.X=Tree^.Disposition.X) and (temp.Move.MoveFrom.Y=Tree.Disposition.Y) do
        begin
          if (Node.Disposition.X=temp.Move.MoveTo.X) and (Node.Disposition.Y=temp.Move.MoveTo.Y) then
          begin
            IsFirstTime:=False;
          end;
          temp:=temp.Next;
        end;
        if IsFirstTime then
        begin
          new(temp);                                 {  }
          temp.Move.MoveFrom.X:=Tree.Disposition.X;  {}
          temp.Move.MoveFrom.Y:=Tree.Disposition.Y;
          temp.Move.MoveTo.X:=Node.Disposition.X;
          temp.Move.MoveTo.Y:=Node.Disposition.Y;
          if List<> nil then List.Prev:=temp;                           {    }
          temp.Next:=List;
          temp.Prev:=nil;
          list:=temp;
        end;
      end;
      {     ""    }
      for i:=Right to Down do
      begin
        if Node^.SimpleStep[i]<>nil then TreeToList(Tree,Node^.SimpleStep[i],List);
        if Node^.JumpStep[i]<>nil then TreeToList(Tree,Node^.JumpStep[i],List);
      end;
    end;

    { }
    var
      PList: PListEntry; {   }
      PTree: TTreeEntry; {  "" }
      X: HNum;
      Y: VNum;
  begin
    PList:=nil;
    {    }
    for X:=a to h do
    begin
      for Y:=1 to 8 do
      begin
        if Board[X,Y]=Turn then
        begin
          { }
          CreateTree(PTree,nil,X,Y);
          {  }
          TreeToList(PTree,PTree,PList);
          { }
          DeleteTree(PTree);
        end;
      end;
    end;
    {  }
    GetMoveList:=PList;
  end;

{---------------------------------------------------------------------}
{                                       }
{---------------------------------------------------------------------}
  Procedure TPosition.DelMoveList(List: PListEntry);
  var
    temp: PListEntry;
  begin
    while List<>nil do
    begin
      temp:=List.Next;
      Dispose(List);
      List:=temp;
    end
  end;

{---------------------------------------------------------------------}
{  .  ,   }
{---------------------------------------------------------------------}
  Function TPosition.GoalFunc():Integer;
  var
    i: HNum;
    j: VNum;
    WhiteR: Integer;
    BlackR: Integer;
  begin
    { }
    WhiteR:=0;
    BlackR:=0;
    for i:=low(i) to high(i) do
    begin
      for j:=low(j) to high(j) do
      begin
        if board[i,j]=white then
        begin
          {    }
          {WhiteR:=WhiteR+16-ord(i)-ord(j);}
          WhiteR:=WhiteR+integer(16-min(ord(i),7)-min(ord(j),7));
        end;
        if board[i,j]=black then
        begin
          {    }
          {BlackR:=BlackR+ord(i)+ord(j);}
          BlackR:=BlackR+integer(max(ord(i),2)+max(ord(j),2));
        end;
      end;
    end;

    if turn=black then
      result:=(WhiteR-BlackR)*10+Random(10)
    else
      result:=(BlackR-WhiteR)*10+Random(10);
  end;

{---------------------------------------------------------------------}
{     .                          }
{ ,   }
{---------------------------------------------------------------------}
  Function TPosition.GoalFunc2():Integer;
  var
    i: HNum;
    j: VNum;
    WhiteR: Integer;
    BlackR: Integer;
    WhiteCount: Integer;
    BlackCount: Integer;
  begin
    { }
    WhiteR:=0;
    BlackR:=0;
    WhiteCount:=0;
    BlackCount:=0;
    for i:=low(i) to high(i) do
    begin
      for j:=low(j) to high(j) do
      begin
        if board[i,j]=white then
        begin
          {     }
          if (i<e) or (j<3) then
            WhiteR:=WhiteR+(16-ord(i)-ord(j))*5
          else
            WhiteR:=WhiteR+16-ord(i)-ord(j);
          {   }
          if InitialPosition[i,j]=Black then
          begin
            WhiteCount:=WhiteCount+1;
          end;
        end;
        if board[i,j]=black then
        begin
          {     }
          if (i>f) or (j>6) then
            BlackR:=BlackR+(ord(i)+ord(j))*5
          else
            BlackR:=BlackR+ord(i)+ord(j);
          {   }
          if InitialPosition[i,j]=White then
          begin
            BlackCount:=BlackCount+1;
          end;
        end;
      end;
    end;

    if turn=black then
    begin
      result:=+BlackCount*50-BlackR*10+Random(10);
    end
    else
    begin
      result:=WhiteCount*50-WhiteR*10+Random(10);
    end;

  end;


{---------------------------------------------------------------------}
{                                      }
{---------------------------------------------------------------------}
  procedure TPosition.SetPiece(X:HNum; Y:VNum; Color:State);
  begin
    Board[X,Y]:=Color;
  end;

  procedure TPosition.SetPiece(Pos:TPlace; Color:State);
  begin
    SetPiece(Pos.X,Pos.Y,Color);
  end;

{---------------------------------------------------------------------}
{                                        }
{---------------------------------------------------------------------}
  procedure TPosition.RemovePiece(X:HNum; Y:VNum);
  begin
    Board[X,Y]:=Space;
  end;

  procedure TPosition.RemovePiece(Pos:TPlace);
  begin
    RemovePiece(Pos.X,Pos.Y);
  end;

{---------------------------------------------------------------------}
{  .    .               }
{---------------------------------------------------------------------}
  procedure TPosition.MakeMove(X1:HNum; Y1:VNum; X2:HNum; Y2:VNum);
  begin
    Board[X2,Y2]:=Board[X1,Y1];
    Board[X1,Y1]:=Space;
  end;

  procedure TPosition.MakeMove(StartPos,EndPos: TPlace);
  begin
    MakeMove(StartPos.X,StartPos.Y,EndPos.X,EndPos.Y);
  end;

  procedure TPosition.MakeMove(M: TMove);
  begin
    MakeMove(M.MoveFrom.X, M.MoveFrom.Y, M.MoveTo.X, M.MoveTo.Y);
  end;


  {------------------------------------------------------------------}
  {                                         }
  {------------------------------------------------------------------}
  function TPosition.IsMovePossible(X1:HNum; Y1:VNum; X2:HNum; Y2:VNum):Boolean;
  var
    list: PListEntry;
    CurMove: PListEntry;
  begin
    list:=GetMoveList();
    CurMove:=list;
    IsMovePossible:=False;
    While CurMove<>nil  do
    begin
      if (CurMove.Move.MoveFrom.X = X1) and (CurMove.Move.MoveFrom.Y = Y1) and (CurMove.Move.MoveTo.X = X2) and (CurMove.Move.MoveTo.Y = Y2) then IsMovePossible:=True;
      CurMove:=CurMove.Next;
    end;
    DelMoveList(list);
  end;

  function TPosition.IsMovePossible(StartPos,EndPos: TPlace):Boolean;
  begin
    IsMovePossible:=IsMovePossible(StartPos.X, StartPos.Y, EndPos.X, EndPos.Y);
  end;

  function TPosition.IsMovePossible(M: TMove):Boolean;
  begin
    IsMovePossible:=IsMovePossible(M.MoveFrom, M.MoveTo);
  end;

{--------------------------------------------------------------------}
{                            }
{--------------------------------------------------------------------}

  function TPosition.GetBestMove(Depth: Cardinal;  Progress:CallBackPosition): TMove;
  const
    Switch=50;
  var
    i:HNum;
    J:VNum;
    Count: Integer;
    WhiteR,BlackR:Integer;
    WhiteSp,BlackSp:Integer;
  begin
    {  }
    BreakFlag:=False;
    {     }
    WhiteR:=0;
    BlackR:=0;
    WhiteSp:=0;
    BlackSp:=0;
    Count:=0;
    for i:=low(i) to high(i) do
    begin
      for j:=low(j) to high(j) do
      begin
        if board[i,j]=white then
        begin
          WhiteR:=WhiteR+16-ord(i)-ord(j);
          Count:=Count+1;
        end;
        if board[i,j]=black then
        begin
          BlackR:=BlackR+ord(i)+ord(j);
        end;
        if(InitialPosition[i,j]=White) and (Board[i,j]<>Black) then BlackSp:=BlackSp+1;
        if(InitialPosition[i,j]=Black) and (Board[i,j]<>White) then WhiteSp:=WhiteSp+1;
      end;
    end;

    {    }
    if ((turn=White) and (WhiteR>Count*5)) or ((turn=Black) and (BlackR>Count*5)) then
    begin
      {      }
      _GetBestMove(Result,Depth,Progress);
    end
    else
    begin
      {      }
      if((turn=white) and (WhiteSp<=3)) or ((turn=black) and (BlackSp<=3)) then
        _GetBestMove2(Result,max(Depth,4),Progress)
      else
        _GetBestMove2(Result,Depth,Progress);
    end;
    {   ,     }
    if BreakFlag then
    begin
      Result.MoveFrom.X:=a;
      Result.MoveTo.X:=a;
      Result.MoveFrom.Y:=1;
      Result.MoveTo.Y:=1;
    end;
  end;

{-------------------------------------------------------------------}
{                      }
{-------------------------------------------------------------------}
  function TPosition._GetBestMove(Var BestMove: TMove; Depth: Cardinal;  Progress:CallBackPosition=nil):Integer;
  var
    List: PListEntry;
    CurMove: PListEntry;
    P: TPosition;
    BestScore, Score: Integer;
    Move: TMove;
    MovesCount,MoveNum: Integer;
    PLst: PListEntry;
  begin
    if depth<>0 then
    begin
      {   }
      List:=GetMoveList();
      {  -  }
      MovesCount:=0;
      MoveNum:=0;
      {  Position}
      P:=TPosition.Create();
      {   }
      P.CopyFrom(Self);
      {  }
      CurMove:=List;
      BestScore:=Low(BestScore);
      {   : }
      while CurMove<>nil do
      begin
        {        }
        P.MakeMove(CurMove.Move);
        {  }
        P.ChangeTurn;
        { GetBestMove   }
        Score:=-P._GetBestMove(Move,Depth-1);
        {O    }
        if Score>BestScore then
        begin
          BestScore:=Score;
          BestMove:=CurMove.Move;
        end;
        {  }
        P.MakeMove(CurMove.Move.MoveTo,CurMove.Move.MoveFrom);
        P.ChangeTurn;
        {    }
        if @Progress<>nil then
        begin
          {    ,      }
          if MovesCount=0 then
          begin
            PLst:=List;
            while PLst.Next<>nil do
            begin
              MovesCount:=MovesCount+1;
              PLst:=PLst.Next;
            end
          end;
          { }
            MoveNum:=MoveNum+1;
          {    }
          Progress(MoveNum,MovesCount);
        end;
        {  }
        Application.ProcessMessages;
        {   }
        if BreakFlag then
        begin
          _GetBestMove:=BestScore;
          exit;
        end;
        { }
        CurMove:=CurMove.Next;
      end;
      {   }
      DelMoveList(List);
      { }
      P.Destroy;
      {   }
      _GetBestMove:=BestScore;
    end
    else {    depth}
    begin
      {  }
      {   }
      _GetBestMove:=GoalFunc();
    end;
  end;

{-------------------------------------------------------------------}
{              }
{-------------------------------------------------------------------}
  function TPosition._GetBestMove2(Var BestMove: TMove; Depth: Cardinal;  Progress:CallBackPosition=nil):Integer;
  var
    List: PListEntry;
    CurMove: PListEntry;
    P: TPosition;
    BestScore, Score: Integer;
    Move: TMove;
    MovesCount,MoveNum: Integer;
    PLst: PListEntry;
  begin
    {    }
    if GetWinner=turn then
    begin
      {    -   }
      {        }
      BestMove.MoveFrom.X:=a;
      BestMove.MoveTo.X:=a;
      BestMove.MoveFrom.Y:=1;
      BestMove.MoveTo.Y:=1;

      _GetBestMove2:=100000+Depth;

      exit;
    end;

    {  ,   }
    if depth<>0 then
    begin
      {   }
      List:=GetMoveList();
      {  -  }
      MovesCount:=0;
      MoveNum:=0;
      {  Position}
      P:=TPosition.Create();
      {   }
      P.CopyFrom(Self);
      {  }
      CurMove:=List;
      BestScore:=Low(BestScore);
      {   : }
      while CurMove<>nil do
      begin
        {        }
        P.MakeMove(CurMove.Move);
        { GetBestMove   }
        Score:=P._GetBestMove2(Move,Depth-1);
        {O    }
        if Score>BestScore then
        begin
          BestScore:=Score;
          BestMove:=CurMove.Move;
        end;
        {  }
        P.MakeMove(CurMove.Move.MoveTo,CurMove.Move.MoveFrom);
        {    }
        if @Progress<>nil then
        begin
          {    ,      }
          if MovesCount=0 then
          begin
            PLst:=List;
            while PLst.Next<>nil do
            begin
              MovesCount:=MovesCount+1;
              PLst:=PLst.Next;
            end
          end;
          { }
            MoveNum:=MoveNum+1;
          {    }
          Progress(MoveNum,MovesCount);
        end;
        {  }
        Application.ProcessMessages;
        {   }
        if BreakFlag then
        begin
          _GetBestMove2:=BestScore;
          exit;
        end;
        { }
        CurMove:=CurMove.Next;
      end;
      {   }
      DelMoveList(List);
      { }
      P.Destroy;
      {   }
      _GetBestMove2:=BestScore;
    end
    else {    depth}
    begin
      {  }
      {   }
      _GetBestMove2:=GoalFunc2();
    end;
  end;


{---------------------------------------------------------------------}
{   .                                          }
{---------------------------------------------------------------------}
  procedure TPosition.break;
  begin
    BreakFlag:=True;
  end;

{-----------------------------------------------------------------}
{      ,   ,     }
{  .    - space                            }
{-----------------------------------------------------------------}
  function TPosition.GetWinner():State;
  label
    1,2,3,4;
  var
    NotWhite: Boolean;
    NotBlack: Boolean;
    i: HNum;
    j: VNum;
  begin
    NotWhite:=False;
    NotBlack:=False;
    { }
    for i:=Low(i) to High(i) do
    begin
      if InitialPosition[i,1]<>white then goto 2;
      for j:=Low(j) to High(j) do
      begin
        if InitialPosition[i,j]=white then
        begin
          if Board[i,j]<>black then
          begin
            NotBlack:=True;
            goto 2;
          end;
        end
        else
        begin
          goto 1; {C }
        end
      end;
      1:{   };
    end;
    2:{ };
    for i:=High(i) downto Low(i) do
    begin
      if InitialPosition[i,8]<>black then goto 4;
      for j:=High(j) downto Low(j) do
      begin
        if InitialPosition[i,j]=Black then
        begin
          if Board[i,j]<>White then
          begin
            NotWhite:=True;
            goto 4;
          end;
        end
        else
        begin
          goto 3; {C }
        end
      end;
      3:{   };
    end;
    4:{  };
    if NotWhite and NotBlack then
    begin
      GetWinner:=Space;
    end
    else
    begin
      if NotWhite then GetWinner:=Black else GetWinner:=White;
    end;
  end;

end.
